

#include "stc15f2k60s2.h"
#include  "gui.h"
#include  "tft.h"
#include  "delay.h" 
#include  "zifu8x16.h"			
#include  "hz16x16.h"		  //16X16
#include  "pff.h"





//
//colorǱɫ
//˵ʹñɫTFTģĻȫʾݡ
void GUI_Clear(u16 color)
{
	u16 i;
	u8 j;
	Address_set(0,0,239,319,0,0);
    for(i=0;i<320;i++)
	 {
	  for (j=0;j<240;j++)
	   	{
        	 Lcd_Write_Data(color);
	    }

	  }
}



//
//(xy)ǵ
//color ǵɫ
//˵ָɫָλϻһ㡣
void GUI_Point(u8 x, u16 y, u16 color)
{  
	Address_set(x,y,x,y,x,y);
	Lcd_Write_Data(color);
}



//8(Bresenham㷨)		  
//(rx,ry,a,b):
//color:ɫ
void gui_circle8(u16 rx,u16 ry,int a,int b,u16 color)
{
	GUI_Point(rx+a,ry-b,color);              
	GUI_Point(rx+b,ry-a,color);                       
	GUI_Point(rx+b,ry+a,color);                           
	GUI_Point(rx+a,ry+b,color);             
	GUI_Point(rx-a,ry+b,color);                  
	GUI_Point(rx-b,ry+a,color);               
	GUI_Point(rx-b,ry-a,color);                      
	GUI_Point(rx-a,ry-b,color);                  
}
//ָλûһָСԲ
//(rx,ry):Բ
//r    :뾶
//color:ɫ
//mode :0,;1,
void GUI_arc(u16 rx,u16 ry,u16 r,u16 color,u8 mode)
{
	int a,b,c;
	int di;	  
	a=0;b=r;	  
	di=3-(r<<1);	//ж¸λõı־
	while(a<=b)
	{
		if(mode)
		for(c=a;c<=b;c++)
		gui_circle8(rx,ry,a,c,color);//ʵԲ
 		else gui_circle8(rx,ry,a,b,color);			//Բ
		a++;
		//ʹBresenham㷨Բ     
		if(di<0)di +=4*a+6;	  
		else
		{
			di+=10+4*(a-b);   
			b--;
		} 							  
	}
}

//ʵľ
//(sx,sy)ϽǶ, 
//(ex,ey)½Ƕ, colorɫ
//: 
//˵ָλϻʵľΡ
void GUI_box(u8 sx,u16 sy,u8 ex,u16 ey,u16 color)
{ 
	u16 temp,temp1,m,n;   
	Address_set(sx,sy,ex,ey,sx,sy); 
    n=ex-sx+1;
	m=ey-sy+1;

	for(temp=0;temp<m;temp++)
	{	 	
		for(temp1=0;temp1<n;temp1++)
	 	{	
			Lcd_Write_Data(color);
		}
	}
}


//
//x0,y0:εϽ
//width,height:εĳߴ
//color:ɫ
void GUI_fill_box(u16 x0,u16 y0,u16 width,u16 height,u16 color)
{	  							   
	if(width==0||height==0)return;//Ƿ.	 
	GUI_box(x0,y0,x0+width-1,y0+height-1,color);	   	   
}


//ԲǾ/ԲǾ
//x,y,width,height:ԲǾελúͳߴ
//r:Բǵİ뾶.
//upcolor:ϰ벿ɫ
//downcolor:°벿ɫ
void GUI_arcrectangle(u16 x,u16 y,u16 width,u16 height,u8 r,u16 upcolor,u16 downcolor)
{
	u16 btnxh=0;
	if(height%2)btnxh=height+1;//ż
	else btnxh=height;

 		GUI_fill_box(x+r,y,width-2*r,btnxh/2,upcolor);			    //
  		GUI_fill_box(x+r,y+btnxh/2,width-2*r,btnxh/2,downcolor);	//
		GUI_fill_box(x,y+r,r,btnxh/2-r,upcolor);					//
		GUI_fill_box(x,y+btnxh/2,r,btnxh/2-r,downcolor);			//
		GUI_fill_box(x+width-r,y+r,r,btnxh/2-r,upcolor);			//
		GUI_fill_box(x+width-r,y+btnxh/2,r,btnxh/2-r,downcolor);	//

	GUI_arc(x+r,y+r,r,upcolor,1);//	
	GUI_arc(x+r,y+btnxh-r-1,r,downcolor,1);//	
	GUI_arc(x+width-r-1,y+r,r,upcolor,1);	 //
	GUI_arc(x+width-r-1,y+btnxh-r-1,r,downcolor,1);//
}



//Ϊ1ֱ
//(sx,sy), 
//(sx,ey)յ, colorɫ
//: 
void GUI_ver(u8 sx,u16 sy,u16 ey,u16 color)
{ 
	u16 temp,m; 
	m=ey-sy+1;  
	Address_set(sx,sy,sx,ey,sx,sy); 
	
	for(temp=0;temp<m;temp++)		 	
	  Lcd_Write_Data(color);			
}


// Ϊ
//x y  ʼ
//tsize εĳ 
//color ɫ
//mode 1   0 
void GUI_triangle(u8 x,u16 y,u8 tsize,u16 color,u8 mode)
{
 u8 xm,i=0;
 u16 ym;
 u8 time;
 xm=x;
 ym=y;
 time=tsize/2;
 if(mode==1)
  {
    for(i=0;i<time;i++)
	 {
	   GUI_ver(xm+i,ym+i,(ym+i+tsize)-i*2,color);
	 
	 } 

  }
 if(mode==0)
  {
    for(i=0;i<time;i++)
	 {
	   GUI_ver(xm-i,ym+i,(ym+i+tsize)-i*2,color);	 	 
	 } 
  }

}


//ʾӢĻַ
//x  y  Ҫʾַĳʼ
//value ʾַ
//dcolor ʾַɫ  bgcolorʾַıɫ
void GUI_sprintf_char(u8 x,u16 y,u8 value,u16 dcolor,u16 bgcolor)	
{  
	u8 i,j;
	u8 *temp=zifu816;    //temp*tempĵַ  tempzifu׵ַ 
 	                    
	temp+=(value-32)*16;   //ȷҪʾֵ
				           //ascii  ǰ32asciiûдzifu Ҫ32
	                       //ÿַ16ֽʾ ڳ16  ǶӦʾλ׵ַ

										 
	 Address_set(x,y,x+7,y+15,x,y);    //		    
		for(j=0;j<16;j++)
		{
			for(i=0;i<8;i++)		    //Ⱥɨ
			{ 		     
			 	if((*temp&(1<<(7-i)))!=0)		   //1  ȻӦλ 				
				  Lcd_Write_Data(dcolor);		   //ʾַɫ
				 
				else				
				  Lcd_Write_Data(bgcolor);		   //ʾɫ		
			}
			temp++;								   //һֽ
		 }

}






//ʾַ 
//x1 y1 ʾĳʼλ
//*str Ҫʾ
//dcolor ʾַɫ
//bgcolor ʾַıɫ  
void GUI_sprintf_hzstr16x(u8 x1,u16 y1,u8 *str,u16 dcolor,u16 bgcolor)	  
{  
	 u8 l=0;
	while(*str)
	{	
	 GUI_sprintf_char(x1+l*8,y1,*str,dcolor,bgcolor);
	 l+=1;
	 str++;
	}	
}



//ʾ5λ  5λ״̬ λʾ ֻʾЧֵ
// x y ʾֵ  
//dat ֵ
//dcolor  ʾֵɫ  bgcolorɫ
void number(u8 x,u16 y,u32 dat,u16 dcolor,u16 bgcolor)				// Ҫʾ	   ٳ
{
 u8 take[5];
 u8 i,m;

 take[0]=dat/10000%10;
 take[1]=dat/1000%10;
 take[2]=dat/100%10;
 take[3]=dat/10%10;
 take[4]=dat%10;

							  //ʾλ
 if(dat/10000)m=5;			  //λ
 else if(dat/1000)m=4;		  //ǧλ
 else if(dat/100)m=3;		  //λ
 else if(dat/10)m=2;		  //ʮλ
 else if(dat/1)m=1;			  //λ
 else if(dat==0)m=1;		  //ֵ0 ֱһλʾ

 for(i=0;i<m;i++)			  //ʾ
  GUI_sprintf_char(x+i*8,y,take[5-m+i]+'0',dcolor,bgcolor);			  //+'0'ʾתΪACCII

}





//ֻʾ10λ
void number10(u8 x,u16 y,u16 dat,u16 dcolor,u16 bgcolor)	// Ҫʾ	 
{

   GUI_sprintf_char(x,y,dat/10%10+'0',dcolor,bgcolor);
   GUI_sprintf_char(x+8,y,dat%10+'0',dcolor,bgcolor); 
}
	


